package visitors;

import expressions.Addition;
import expressions.BinaryExpression;
import expressions.Brackets;
import expressions.Division;
import expressions.Expression;
import expressions.Literal;
import expressions.Multiplication;
import expressions.Subtraction;

public class EvalVisitor implements Visitor {
    private int result = 0;

    public int getResult() {
        return result;
    }

    @Override
    public void visit(Expression e) {
        e.accept(this);
    }

    @Override
    public void visit(Literal l) {
        result = l.getValue();
    }

    @Override
    public void visit(Brackets b) {
        visit(b.getExpression());
    }

    @Override
    public void visit(Addition a) {
        visit(a.getLeftHand());
        int res1 = result;

        visit(a.getRightHand());
        int res2 = result;

        result = res1 + res2;
    }

    @Override
    public void visit(Subtraction s) {
        visit(s.getLeftHand());
        int res1 = result;

        visit(s.getRightHand());
        int res2 = result;

        result = res1 - res2;
    }

    @Override
    public void visit(Multiplication m) {
        visit(m.getLeftHand());
        int res1 = result;

        visit(m.getRightHand());
        int res2 = result;

        result = res1 * res2;
    }

    @Override
    public void visit(Division d) {
        visit(d.getLeftHand());
        int res1 = result;

        visit(d.getRightHand());
        int res2 = result;

        result = res1 / res2;
    }
}
